<!--
    Original overlay code and implementation by SimpleAOB
    Contact:
        Discord - SimpleAOB#9999 (preferred)
        Email - simple(@at)bakkesplugins(dot)com
    Credits:
        Default images and guidance on art by RJsaurus - https://twitter.com/deeposaurus
        BakkesWebApi by gboddin - Heavily modified and extended by SimpleAOB
            - Now available at: https://gitlab.com/bakkesplugins/sos/sos-plugin
-->

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>SOS - Rocket League OBS Browser Source Overlay</title>
    <style>
        ${require('../out/css/main.min.css')}
    </style>
</head>
<body>
<div class="page-container">
    <div class="waiting-for-websocket">
        <div class="technical-difficulties hidden"></div>
        <div class="text">
            Waiting for Websocket Server to connect...
        </div>
    </div>
    <div class="upnext">
        <div class="teams right">
            <div class="svg-bg">
                <svg xmlns="http://www.w3.org/2000/svg" width="307px" height="145px">
                    <rect fill-rule="evenodd" class="logo-color-bg" fill="#f26522" width="307" height="145"/>
                </svg>
            </div>
            <div class="logo"><img></div>
            <div class="abbreviation"></div>
        </div>
        <div class="separator">
            <svg xmlns="http://www.w3.org/2000/svg" width="56px" height="145px">
                <path fill-rule="evenodd" fill="rgb(255, 255, 255)" width="56" height="145/>
            </svg>
        </div>
        <div class="teams left">
            <div class="svg-bg">
                <svg xmlns="http://www.w3.org/2000/svg" width="307px" height="145px">
                    <rect fill-rule="evenodd" class="logo-color-bg" fill="#0090d3" width="307" height="145"/>
                </svg>
            </div>
            <div class="logo"><img></div>
            <div class="abbreviation"></div>
        </div>
        <div class="main-text-bg">
            <svg xmlns="http://www.w3.org/2000/svg" width="385px" height="145px">
                <rect fill-rule="evenodd" fill="rgb(29, 29, 29)" width="385" height="145"/>
            </svg>
        </div>
        <div class="upnext-text">
            UP NEXT
        </div>
    </div>
</div>
<script>${require('vendor/jquery-3.4.1/jquery-3.4.1.min.js')}</script>
<script>${require('../out/js/base.js')}</script>
<script>
    //!!! Register the websocket listeners before attempting to connect
    WsSubscribers.subscribe("ws", "open", function() {
        $(".waiting-for-websocket").addClass("hidden");
        WsSubscribers.send("cb", "first_connect", {
            'name': 'TickerUpnext',
            'version': ${require('../version.txt')}
        });
        setInterval(function () {
            WsSubscribers.send("cb", "heartbeat", "heartbeat");
        }, 1000);
    });

    WsSubscribers.subscribe("ws", "open", function() {
        $(".waiting-for-websocket").addClass("hidden");
    });

    WsSubscribers.subscribe("ws", "error", function() {
        $(".waiting-for-websocket .text").text("[002] There has been an error with the Rocket League connection. Please stand by");
        $(".waiting-for-websocket").removeClass("hidden");
    });

    WsSubscribers.subscribe("ws", "close", function() {
        $(".waiting-for-websocket .text").text("[004] Connection to Rocket League has gone away. Please stand by");
        $(".waiting-for-websocket, .technical-difficulties").removeClass("hidden");
    });

    WsSubscribers.init(49322, false, [
        "game:update_tick",
        "cb:heartbeat"
    ]);
</script>
<script>
    let teamMap = ${require('../../team_logos/map.json')};
    WsSubscribers.subscribe("sos", "up_next_teams_update", (d) => {
        let leftLower = d.left.name.toLowerCase();
        let rightLower = d.right.name.toLowerCase();

        if (teamMap.hasOwnProperty(leftLower)) {
            let teamLeft = teamMap[leftLower];
            $('.teams.left .logo img').attr('src', `../team_logos/${teamLeft.logo}`);
            $('.teams.left .logo-color-bg').attr('fill', teamLeft.background);
            $('.teams.left .abbreviation').css('color', teamLeft.black_text ? 'black' : 'white');
        } else {
            $('.teams.left .logo img').attr('src', `../team_logos/DEFAULT.png`);
            $('.teams.left .logo-color-bg').attr('fill', '#0090d3');
            $('.teams.left .abbreviation').css('color', 'white');
        }

        if (teamMap.hasOwnProperty(rightLower)) {
            let teamRight = teamMap[rightLower];
            $('.teams.right .logo img').attr('src', `../team_logos/${teamRight.logo}`);
            $('.teams.right .logo-color-bg').attr('fill', teamRight.background);
            $('.teams.right .abbreviation').css('color', teamRight.black_text ? 'black' : 'white');
        } else {
            $('.teams.right .logo img').attr('src', `../team_logos/DEFAULT.png`);
            $('.teams.right .logo-color-bg').attr('fill', '#f26522');
            $('.teams.right .abbreviation').css('color', 'white');
        }

        $('.teams.left .abbreviation').text(d.left.abbreviation);
        $('.teams.right .abbreviation').text(d.right.abbreviation);
    });
</script>
<script>${require('sos-plugins/testing/js/testing.js')}</script>
</body>
</html>